    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * -------------------------------
    028 * MultiplexMappingDefinition.java
    029 * -------------------------------
    030 * (C)opyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: MultiplexMappingDefinition.java,v 1.3 2005/10/18 13:33:53 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 22-Nov-2003 : Initial version
    040 *
    041 */
    042
    043package org.jfree.xml.util;
    044
    045import java.util.HashMap;
    046
    047/**
    048 * Maps a class to ...
    049 */
    050public class MultiplexMappingDefinition {
    051
    052    /** The class. */
    053    private Class baseClass;
    054
    055    /** The attribute name. */
    056    private String attributeName;
    057
    058    /** The forward mappings. */
    059    private HashMap forwardMappings;
    060
    061    /** The reverse mappings. */
    062    private HashMap reverseMappings;
    063
    064    /**
    065     * Creates a new mapping definition.
    066     *
    067     * @param baseClass  the class.
    068     * @param attributeName  the attribute name.
    069     * @param entries  the entries.
    070     */
    071    public MultiplexMappingDefinition(final Class baseClass,
    072                                      final String attributeName,
    073                                      final MultiplexMappingEntry[] entries) {
    074
    075        this.attributeName = attributeName;
    076        this.baseClass = baseClass;
    077        this.forwardMappings = new HashMap();
    078        this.reverseMappings = new HashMap();
    079
    080        for (int i = 0; i < entries.length; i++) {
    081            final MultiplexMappingEntry entry = entries[i];
    082            this.forwardMappings.put(entry.getAttributeValue(), entry);
    083            this.reverseMappings.put(entry.getTargetClass(), entry);
    084        }
    085    }
    086
    087    /**
    088     * Returns the attribute name.
    089     *
    090     * @return The attribute name.
    091     */
    092    public String getAttributeName() {
    093        return this.attributeName;
    094    }
    095
    096    /**
    097     * Returns the class.
    098     *
    099     * @return The class.
    100     */
    101    public Class getBaseClass() {
    102        return this.baseClass;
    103    }
    104
    105    /**
    106     * Returns a mapping entry for a type.
    107     *
    108     * @param type  the type.
    109     *
    110     * @return The mapping entry.
    111     */
    112    public MultiplexMappingEntry getEntryForType(final String type) {
    113        return (MultiplexMappingEntry) this.forwardMappings.get(type);
    114    }
    115
    116    /**
    117     * Returns a mapping entry for a class.
    118     *
    119     * @param clazz  the class.
    120     *
    121     * @return The mapping entry.
    122     */
    123    public MultiplexMappingEntry getEntryForClass(final String clazz) {
    124        return (MultiplexMappingEntry) this.reverseMappings.get(clazz);
    125    }
    126}